package com.malk.KLNM.controller;

import com.alibaba.fastjson.JSON;
import com.malk.KLNM.server.HXClient;
import com.malk.server.common.McR;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.io.File;
import java.util.Map;

@Slf4j
@RestController
@RequestMapping()
public class HXController {
    @Autowired
    private HXClient hxClient;


    @PostMapping("h3yun-http")
    McR http(@RequestBody Map<String, String> data, @RequestParam String code) {
        //deleteFile("/home/files");
        log.info("氚云http请求, code = {}, body = {}", code, JSON.toJSONString(data));
       System.out.println("氚云http请求, code = "+code+", body = "+JSON.toJSONString(data));
      //  deleteFile("D:\\本地下载aaa\\");
        String type = String.valueOf(data.get("HIH3type"));
        if (type.equals("CStype01") || type.equals("CStype02")) {//船次附件数据上传
            String sss= hxClient.CStoDP( data);
        }
        if (type.equals("CW01")|| type.equals("CW02")) {//财务附件数据上传 CW01:付款    CW02:收款
            String sss= hxClient.CWtoDP( data);
        }
        //  String sss= hxClient.syncDP(String.valueOf(data.get("attachments")), String.valueOf(data.get("projectName")), String.valueOf(data.get("typeName")));
        return McR.success(UtilMap.map("status", "是"));
    }
public  void  deleteFile(String directoryPath){
    // 创建一个表示目录的File对象
    File directory = new File(directoryPath);

    // 获取目录下的所有文件和目录
    File[] files = directory.listFiles();

    // 确保目录存在且不是文件本身
    if (files != null && directory.isDirectory()) {
        for (File file : files) {
            // 删除文件
            if (file.isFile()) {
                System.out.println("Deleting file: " + file.getName());
                file.delete();
            }
        }
    }
}



}
